image: docker:19.03.7
services:
  - docker:19.03.7-dind
stages:
  - build
  - deploy

##############################################################################
##                              Variables                                   ##
##############################################################################
variables:
  APP_NAME: gitops-argocd-demo
  CI_REGISTRY_IMAGE: haarvester/$APP_NAME
  CD_CHART_REPO: webapp-chart
  CD_GIT_REPOSITORY: git@gitlab.com:ruslan.yeraliyev/$CD_CHART_REPO.git
  CD_MANIFEST_FILE: Chart.yaml
  TAG: $CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA

##############################################################################
##                              Custom Script                               ##
##############################################################################
before_script:
  - echo $CI_REGISTRY_IMAGE:$TAG $PWD
  # login
  - docker login -u haarvester -p mudengi0206

after_script:
  - docker image prune -af

##############################################################################
##                              Build Image                                 ##
##############################################################################
build_image:
  stage: build
  script:
    # Docker Build && Push image
    - cat Dockerfile
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - >
      docker build
      --network host
      --cache-from $CI_REGISTRY_IMAGE:latest
      --tag $CI_REGISTRY_IMAGE:$TAG
      .
    - docker push $CI_REGISTRY_IMAGE:$TAG


##############################################################################
##                              Deployments                                 ##
##############################################################################
tag_latest_image:
  stage: deploy
  variables:
    GIT_STRATEGY: none
  script:
    - docker pull $CI_REGISTRY_IMAGE:$TAG
    - docker tag $CI_REGISTRY_IMAGE:$TAG $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest


update_manifest:
  stage: deploy
  variables:
    GIT_STRATEGY: none
  retry: 2
  script:
    # Add SSH key to root
    - mkdir -p /root/.ssh
    - echo "$SSH_PRIVATE_KEY" > /root/.ssh/id_rsa
    - ssh-keyscan -H gitlab.com > /root/.ssh/known_hosts
    - chmod 600 /root/.ssh/id_rsa
    # Git
    - apk add --no-cache git
    - git config --global user.name $APP_NAME
    - git config --global user.email $APP_NAME"@gitlab.com"
    - git clone --single-branch --branch master $CD_GIT_REPOSITORY
    - cd webapp-chart/app1
    # Helm
    - >
      docker run --rm -v ${PWD}:/workdir mikefarah/yq:3.2.1 yq write 
      --inplace --verbose $CD_MANIFEST_FILE appVersion $TAG
    - cat $CD_MANIFEST_FILE
    - git commit -am "update image tag" && git push origin master
